if(!dojo._hasResource['com.ibm.widgets.NewPageDialog']){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource['com.ibm.widgets.NewPageDialog'] = true;
dojo.provide('com.ibm.widgets.NewPageDialog');
dojo.require('dijit.Dialog');
dojo.require("dojo.i18n");
dojo.requireLocalization("com.ibm.bundles", "Shelf");
dojo.requireLocalization("com.ibm.bundles", "PageCreatorDialog");
dojo.declare('com.ibm.widgets.NewPageDialog',
	[dijit.Dialog],
    {
		shelfBundle: null,
		dialogBundle: null,
		blankImg: "",
		autofocus: false,
		showMakePrivate: true,
		showFriendlyURL: true,
		showPageTemplate: false,
		value: {},
		
		templateString: '<div class="lotusDialogBorder lotusui30 lotusui" waistate="labelledby-${id}" wairole="dialog" role="dialog" index="-1" aria-labelledby="${id}" dojoAttachPoint="dialogDiv">' +
						'<div class="lotusDialog">' +
							'<h1>' +
								'<a href="javascript:void(0);" dojoAttachPoint="closeButtonNode" class="lotusBtnImg lotusClose" title="${closeText}">' +
									'<img src="${_blankGif}" alt="" aria-label="${closeText}" />' +
									'<span class="lotusAltText">X</span>' +
								'</a>' +
								'<span dojoAttachPoint="titleNode">${titleText}</span>' +
							'</h1>' +
							'<form dojoAttachPoint="newPageForm,containerNode" action="javascript:;">' +
								'<div class="lotusDialogContent">' +
									'<div>' +
										'<div class="lotusMessage" dojoAttachPoint="newPageError" style="display: none" role="alert">' +
											'<span>${nlsTitleError}</span>' +
										'</div>' +
										'<div><label for="${id}_name">${nlsPageTitle}</label></div>' +
										'<div><input id="${id}_name" type="text" name="title" dojoAttachPoint="typingNode, focusNode" size="24"/></div><br />' +
										
										'<div dojoAttachPoint="divFriendlyURL">'+
											'<div><label for="${id}_friendly">${nlsFriendlyURL}</label></div>' +
											'<div><input id="${id}_friendly" type="text" name="friendlyURL" dojoAttachPoint="newPageFriendlyURL" size="24"/></div>'+
										'</div><br />' +
										
										'<div dojoAttachPoint="divPrivate">' +
											'<input id="${id}_private" type="checkbox" name="private" dojoAttachPoint="makePrivate"/><span> <label for="${id}_private">${nlsMakePrivate}</label></span>' +
										'</div><br />' +
										'<div dojoAttachPoint="divPageTemplate">' +
											'<div><b style="margin-right:10px">${nlsPageTemplate}</b><span dojoAttachPoint="divSelectedTemplateName" style="margin-right:10px">${nlsDefault}&nbsp;</span><a href="javascript:void(0);" class="lotusAction" dojoAttachPoint="showHideTemplateNode">${nlsChange}</a></div>' +
											'<div dojoAttachPoint="divTemplate" style="display: none">' +
												'<div><label for="${id}_template">${nlsPageTemplateLabel}</label></div>' +
												'<div><select dojoAttachPoint="templateSelect" id="${id}_template" name="template"><option selected value="">${nlsNoTemplate}</option></select></div>' +
											'</div>' +
										'</div>' +
									'</div>' +
								'</div>' +
								'<div class="lotusDialogFooter" dojoAttachPoint="dialogFooter">' +
									'<input value="${okText}" class="lotusFormButton" dojoAttachPoint="submitDialog" type="submit"/> ' +
									'<a href="javascript:void(0);" class="lotusAction" dojoAttachPoint="dialogCancel">${cancelText}</a>' +
								'</div>' +
							'</form>' +
						'</div>' +
					'</div>',
								
		postMixInProperties: function() {
			// fix for Dojo 1.6 bug that attempts to add an empty content parameter that effectively
			// clears the contents of our containerNode even though the template defines some
			delete this.content;
			if(this.params) {
				delete this.params.content;
			}
			if(this.cssStateNodes) {
				delete this.cssStateNodes.closeButtonNode;
			}
			this.shelfBundle = dojo.i18n.getLocalization("com.ibm.bundles", "Shelf");
			this.dialogBundle = dojo.i18n.getLocalization("com.ibm.bundles", "PageCreatorDialog");
			this.cancelText = this.shelfBundle["add_content_cancel"];
			this.closeText = this.shelfBundle["add_content_close"];
			this.okText = this.dialogBundle["page_dialog_create_page"];
			this.nlsPageTitle = this.dialogBundle["page_dialog_page_name"];
			this.nlsTitleError = this.shelfBundle["new_feed_enterTitle"];
			this.nlsFriendlyURL = this.dialogBundle["page_dialog_friendly_url_name"];
			this.nlsMakePrivate = this.dialogBundle["page_dialog_make_private"];
			this.titleText = this.dialogBundle["page_dialog_create_page"];		
			this.nlsPageTemplate = this.dialogBundle["page_dialog_page_template"];
			this.nlsPageTemplateLabel = this.dialogBundle["page_dialog_page_template_label"];
			this.nlsNoTemplate = this.dialogBundle["page_dialog_no_template"];
			this.nlsDefault = this.dialogBundle["page_dialog_default"];
			this.nlsChange = this.dialogBundle["page_dialog_change"];
			this.inherited(arguments);
		},
		
		postCreate: function() { 
			this.inherited(arguments);
			
			this.submitDialog.onclick = dojo.hitch(this,function(){this.submit();return false;});
			this.closeButtonNode.onclick = this.dialogCancel.onclick = dojo.hitch(this,function(){this.cancel();return false;});
			
			if (!this.showMakePrivate) { dojo.destroy(this.divPrivate); delete this.divPrivate; }
			
			this.connect(this.typingNode, "onkeyup", function(){
				if (this.typingNode.value != "") { this.newPageError.style.display="none"; }
			});
			
			this.connect(this.typingNode, "onkeypress", dojo.hitch(this, function(event) {
	            if (event.keyCode==dojo.keys.ENTER) { this.submit(); }
			}));
			
			if (this.showFriendlyURL){
				this.connect(this.typingNode, "onkeyup", function(){ 
					this.filterFriendlyURL(this.typingNode.value);
				});
				this.connect(this.newPageFriendlyURL, "onkeyup", function(){
					this.filterFriendlyURL(this.newPageFriendlyURL.value);
				});
			} else {
				dojo.destroy(this.divFriendlyURL);
				delete this.divFriendlyURL;
			}
			
			if (this.showPageTemplate) {
				this.connect(this.showHideTemplateNode, "onclick", this.fireEventToTemplateSelectDialog);
			}
			else {
				dojo.destroy(this.divPageTemplate);
				delete this.divPageTemplate;
			}
		},
		fireEventToTemplateSelectDialog: function () {
            // summary:
            //      When the Template Select dialog is called the first time, it will initialize itself
            //        and fire back the value of the default template. On subsequent calls, the dialog will
            //        display itself and send back the id of the selected template.
            if(this.showPageTemplate){
				var widgetModel = com.ibm.mashups.iwidget.model.Factory.getGlobalWidgetModel();
				com.ibm.mashups.services.ServiceManager.getService("eventService").fireEvent("templateSelect", "onTemplateSelect", this.templateSelect.options[0].value, null, "newPage");
            }
		},
		_templateSelectChanged: function(value) {
            // summary:
            //      Callback from the Template Select dialog with the selected template value
            if(this.showPageTemplate){
				if (value.resourceName) {
					this.divSelectedTemplateName.innerHTML = value.resourceName;
				}
				this.templateSelect.options[0].value = value.resourceValue;
            }
		},
		_validatePageName: function(title) {
			dojo["require"]("com.ibm.mm.builder.builderpre");
			var cwm = com.ibm.mm.builder.coreWidgetsMessages;
		    if (!title) {
		        return false;
		    }
		    if (title.length === 0) {
		        alert(cwm.E_PAGE_UTIL_INVALID_NAME_EMPTY_0);
		        return false;
		    }
		    title = dojo.trim(title);
		    if (title.length === 0) {
		        alert(cwm.E_PAGE_UTIL_INVALID_NAME_BLANK_0);
		        return false;
		    }
		    
		    if (title.length >= 256) {
		        alert(cwm.E_PAGE_UTIL_INVALID_NAME_LENGTH_0);
		        return false;
		    }
		    
		    var match = ibmConfig[com.ibm.mashups.enabler.services.ConfigConstants.BUILDER_TITLE_FILTER_REGEXP];
		    if (match) {
		        if (title.match(match)) {
		            alert(cwm.E_PAGE_UTIL_INVALID_NAME_CHAR_0);
		            return false;
		        }
		    }
		    return true;
		},
		
		submit: function(){
			var pagename = this.typingNode.value.replace(/<(?:\/?).+?>/g,"");  // remove tags to protect against XSS
			this.typingNode.value = pagename;
			// shows error if there is no page title.
			if (pagename == "") {
				this.newPageError.style.display = "block";
				return;
			}
			//bug 13511, xss check before submit.
			if (!this._validatePageName(pagename)) { return; }
			
			dojo.attr(this.submitDialog, "disabled", "disabled");
			this.hide();
			this.beforeSubmit();
			//bug 12089, fix multi click to create page multi times.
			var self = this;
			setTimeout(function(){
				self.onSubmit();
			}, this.duration * 2);  // time needed for create dialog to hide and waiting dialog to appear);
		},
		
		cancel: function(){
             if(!this._beingDestroyed){
                 this.hide();
             } 
		},
		
		onChange: function(/*Object*/arg){
		},
		
		onComplete: function(){
		},
		
		beforeSubmit: function(){
		},
		
		onSubmit: function() {
            if (ibmCfg.themeConfig.launchEditModeForNewPages) {
                com.ibm.pb.control.RenderingController.getController().launchEditModeForNewPage = true;
            }
			// When the user presses the Submit button.
			this.value = dojo.formToObject(this.newPageForm);
			// if user does not have editor rights on parent page, they have no choice
			//   and are always making private pages so we need to set the parameter
			if (!this.value["private"] && !this.canMakePublic && this.canMakePrivate) { 
				this.value["private"]="on";
			}
			this.value.onComplete = this.onComplete;
			this.onChange(this.value);
		},
		
		layout: function() {
			if(this.domNode.style.display != "none") {
				/* 
				 * Calling internal API to fix a bug where resizing the viewport
				 * does not resize the dialog, but simply calls "layout" and should
				 * also call "_size"
				 */
				this._size();
			}
			return this.inherited(arguments);
		},
		
		focus: function(){
			this.newPageError.style.display="none";
			if(this.showMakePrivate){this.makePrivate.checked = false;}
			this.typingNode.value = "";
			if(this.showFriendlyURL){this.newPageFriendlyURL.value = "";}
			this.submitDialog.removeAttribute("disabled");
			this.show();
			this.focusNode.focus();
            
            if(this.showPageTemplate){this.fireEventToTemplateSelectDialog();}  // get the default template value
		},
		
		filterFriendlyURL: function(/*String*/textToFilter) {
		// summary: filters the given text into something more acceptable for the friendly url.
		// textToFilter: text for the filter to run on.
			var friendly = textToFilter.replace(/[!\*\'\(\);:@&=+$,\/?%#\[\]\s]/g,'-');
			this.newPageFriendlyURL.value = friendly;
		},
		destroy: function () {
			this.submitDialog.onclick = null;
			this.closeButtonNode.onclick = null;
			this.inherited(arguments);		
		}
    }
);

}
